/****************************************************/
/* File: cm.l                                       */
/* Lex specification for C-Minus                    */
/* Kenneth C. Louden                                */
/* CS 153 - Spring, 2006 - 3/22/06                  */
/****************************************************/

%{
#include "cm.tab.h"
%}

digit       [0-9]
number      {digit}+
letter      [a-zA-Z]
identifier  {letter}+
newline     [\n\012]
whitespace  [ \t\r]+

%%

"else"          {return ELSE;}
"if"            {return IF;}
"int"           {return INT;}
"return"        {return RETURN;}
"void"          {return VOID;}
"while"         {return WHILE;}
"<="            {return LE;}
">="            {return GE;}
"=="            {return EQ;}
"!="            {return NE;}
{number}        {return NUM;}
{identifier}    {return ID;}
{newline}       {/* skip whitespace */}
{whitespace}    {/* skip whitespace */}
"/*"            { int c;
                  for (;;)
                  { while ( (c = input()) != '*' && c != EOF );
                    if ( c == '*' )
                    { while ( (c = input()) == '*' ) ;
                      if ( c == '/' )
                        break;    /* found the end */
                    }
                    if ( c == EOF ) { break; } /* kludge, but an error anyway */
                  }
                }
.               {return yytext[0];}

%%

int yywrap(void)
{ return 1; }
